label forest_1:
    $ dangerAreaDepth = 1
    call areaMarker("forest") from _call_areaMarker_6 
    scene forest_dynamic with myDissolve

    if(
    game.objective[0].completed == True
    and game.objective[1].completionFlags[0] == False
    and game.objective[1].completionFlags[1] == False
    and game.objective[1].completed == False):
        $ game.objective[1].completionFlags[0] = True
        "As you walk through the forest, you look around to find Lulu..."
        "[imp]" "Hey [pronouns.mister]~! Over here!"
        pause 1.0
        call cutscene_succubus_forest_1 from _call_cutscene_succubus_forest_1 

    menu:
        "Go deeper":
            call randomForestEvent(2) from _call_randomForestEvent 
        "Wander around":
            call randomForestEvent(1) from _call_randomForestEvent_1 
        "Visit Lulu" if game.objective[0].completed == True:
            call imp_talk from _call_imp_talk_1 
        "Enter town":
            jump town_central
    jump forest_1

label forest_2:
    $ dangerAreaDepth = 2
    call areaMarker("forest") from _call_areaMarker_10 
    scene forest_dynamic with myDissolve
    
    if (game.objective[3].completionFlags[0] == True
    and game.objective[3].completionFlags[1] == False):
        $ game.objective[3].completionFlags[1] = True
        call cutscene_succubus_alraune_0 from _call_cutscene_succubus_alraune_0

    if (game.objective[3].completed == False
    and game.objective[2].completed == True):
        $ highlight = getHighlightText("Hidden path")
    else:
        $ highlight = "Hidden path"

    menu:
        "Go deeper":
            call randomForestEvent(3) from _call_randomForestEvent_2 
        "Wander around":
            call randomForestEvent(2) from _call_randomForestEvent_3 
        "[highlight]" if (player.level > 5 or game.objective[2].completed == True):
            "There's a path leading out of the forest here..."
            "It seems to lead out of the village, it's covered in leaves and other foliage"
            "There seems to be another path branching out from this one, leading to a small pond"
            
            if (game.objective[3].completed == False
            and game.objective[2].completed == True):
                $ highlight = getHighlightText("Follow the path")
            else:
                $ highlight = "Follow the path"

            menu:
                "[highlight]":
                    $ alrauneEvents = [1,2,3,4]
                    call move("alraunemaze_1h1y") from _call_move_7
                "Small pond":
                    call forest_pond from _call_forest_pond 
                "Back":
                    pass
        "Head towards town":
            call randomForestEvent(1) from _call_randomForestEvent_4 
    jump forest_2
    
label forest_3:
    $ dangerAreaDepth = 3
    call areaMarker("forest") from _call_areaMarker_11 
    scene forest_dynamic with myDissolve

    if (game.objective[0].completed == True
    and game.objective[1].completionFlags[0] == True
    and game.objective[1].completionFlags[1] == False
    and game.objective[1].completed == False
    and player.level > 4):
        call cutscene_succubus_forest_2 from _call_cutscene_succubus_forest_2 
        
    if (game.objective[1].completionFlags[1] == True 
        and game.objective[1].completed == False):
        $ highlight = getHighlightText("Enter cave")
    else:
        $ highlight = "Cave"

    scene forest_dynamic with myDissolve

    menu:
        "[highlight]":
            call cave_1 from _call_cave_1 
        "Wander around":
            call randomForestEvent(3) from _call_randomForestEvent_5 
        "Wooden shack" if (slime.profile.name == 'Skye'):
            call forest_woodenShack from _call_forest_woodenShack 
        "Head towards town":
            call randomForestEvent(2) from _call_randomForestEvent_6 
    jump forest_3

default enoughDonations = False
default amountToDonate = 0
default donatedAmount = 0
label forest_pond:
    if game.foundPond == False:
        "You decide to explore the forest a little deeper and head towards the pond."
        show pond_dynamic with myDissolve
        "...After walking for a while you end up at the pond. There's a sign next to the pond."
        "\"Those who donate to the lady of the pond will have their purity restored\""
        "There's a small box near the pond as well. It looks like you can deposit gold in there..."
    show pond_dynamic with myDissolve
    $ game.foundPond = True
    menu:
        "Donate":
            "How much gold will you donate?"
            menu:
                "10":
                    $ amountToDonate = 10
                "25":
                    $ amountToDonate = 25
                "50":
                    $ amountToDonate = 50
                "Back":
                    jump forest_pond
            
            if player.money >= amountToDonate:
                "You donate [amountToDonate] gold before getting in the water."
                call loseMoney(player, amountToDonate) from _call_loseMoney
                $ donatedAmount += amountToDonate
                pause 1
                "..."
                $ enoughDonations = donatedAmount + rand(1, 90) > 70
                if(enoughDonations):
                    "You feel the water get warmer as your lust decreases."
                    "{color=#0f0}Arousal and weaknesses restored!{/color}"
                    call cleanseSoul from _call_cleanseSoul 
                    $ donatedAmount = 0
            else:
                "You don't have enough money..."
        "Back" if witchPathUnlocked == False:
            return

        "Wooden shack" if witchPathUnlocked:
            call move("forest_woodenShack") from _call_move_8

        "Forest" if witchPathUnlocked:
            call move("forest_2") from _call_move_9

    jump forest_pond            

label forest_woodenShack:
    scene shrine_dynamic with myDissolve
    if not game.slimeHouseUnlocked:
        "You see a wooden shack nearby..."
        "It looks old, yet still in good condition..."
        "Go inside?"
    menu:
        "Go inside":
            label forest_woodenShack_menu_inside:
            scene shrine_inside_dynamic with myDissolve
            if not game.slimeHouseUnlocked:
                "As you try to go inside you find the floor sticky with slime..."
                "...You hear the drooping of slime nearby. It sounds like there's someone else here..."
                "..."
                "...Suddenly, you hear a familiar voice calling out to you."
                "[slime]" "Hey hey~"
                show slime_main with myDissolve
                "[slime]""It's you again~!"
                "[slime]""Welcome to my little house, [pronouns.mister]~"
                "[slime]""I found this little shack in the forest and decided to make it my own~ Pretty cool, right?"
                "[slime]""The best part is that it's pretty secluded so most slimes don't even know this spot exists~!"
                "[slime]""Anyway, what are you doing here? Do you want to talk about something?"
                if slimePrincess in allPartyMembers:
                    "[slimePrincess]" "Fufu~ are you visiting her out of pity or something~?"
                    "[slimePrincess]" "Look at this place, it's practically a dump compared to my castle~"

            elif witchInvited and witchInroCutscene == False:
                $ witchInroCutscene = True
                "You enter the shrine... you hear a faint sound of slime getting quieter"
                show witch cat smile with myDissolve
                "[witch]" "Welcome!"
                "[witch]" "So, you're an adventurer, right? There's some things I'd like to do!"
                "[witch]" "Stand still, please."
                play audio holy7
                show witch cat smile with Fade(0.1, .3, 0.3, color="#fff")
                $ witchUnlockedWeaknesses = True
                pause 0.5
                "..."
                "...You don't really feel any different..."
                "[witch]" "Right~"
                "[witch]" "Purrfect!"
                "[witch]" "As I'm sure you know, all girls have different attacks."
                "[witch]" "and they deal different types of damage"
                "[witch]" "As an adventurer, you gain certain weaknesses after experiencing certain attacks."
                "[witch]" "Buuut, I can help you become more resistant against certain attacks!"
                "[witch]" "At the expense that you'll also become weaker against a certain type."
                "[witch]" "Why don't you try it out?"
                call screen weaknessesSelect with myDissolve
                "[witch]" "Whenever you're struggling to fight someone you can sacrifice useless weaknesses to help more relevant ones!"
                if player.weaknesses.hands.resistance == -1:
                    "[witch]" "Hands, for example, are barely used so good job setting that one to -1!"
                else:
                    "[witch]" "Hands, for example, are barely used so you should try setting that one to -1!"
                
                    call screen weaknessesSelect with myDissolve

                    if player.weaknesses.hands.resistance == -1:
                        "[witch]" "Purrfect~!"
                    elif player.weaknesses.hands.resistance > 0:
                        "[witch]" "That's... fine too!"
                    else:
                        "[witch]" "Or not, I suppose~!"

                "[witch]" "Well, it looks like you figured it all out~!"
                show witch cat smile at lookAround2() with myDissolve
                pause 1
                show witch cat smile at lookBack2() with myDissolve
                "[witch]" "Phew... All that magic sure is exhausting though."
                "[witch]" "In fact, there's one more thing I'd like to do before you go if you don't mind."
                "[witch]" "Hold on!"
                hide witch cat smile with myDissolve
                "[witch.profile.name] closes her eyes and focuses her magic inward..."
                "A bright flash appears and..."
                play audio holy7
                show witch lean with Fade(.1, .3, .2, color="#fff")
                "[witch]" "Much better~!"
                "[witch]" "Ahaha~ You didn't really think I was a kitty, did you?"
                "[witch]" "Come on, a talking cat? In witch's clothing?"
                hide witch lean with myDissolve
                show witch smuglean with myDissolve
                "[witch]" "It's cute how gullible you are~"
                "[witch]" "In fact..."
                call enterCombat(witch) from _call_enterCombat_2
                show witch lean with myDissolve
                "[witch]" "Ahaha, well done~"
                "[witch]" "It's a shame I didn't get to take your mana, but I'm proud of you~"

                "[witch]" "Thanks, cutie~ That was fun~"
                
                if player.weaknesses.hands.resistance == -1:
                    hide witch lean with myDissolve
                    show witch laugh with myDissolve
                    "[witch]" "Ahaha, I can't believe you actually lowered your hands weakness by the way~"
                    "[witch]" "Maybe that just shows how gullible you are, huh~?"
                elif player.weaknesses.hands.resistance > 0:
                    hide witch lean with myDissolve
                    show witch laugh with myDissolve
                    "[witch]" "I'm actually surprised you decided to increase your hands resistance~"
                    "[witch]" "Did you do it because you knew I was gonna use it against you? Or did you just want to tease me~?"
                hide witch laugh with myDissolve
                hide witch smuglean with myDissolve
                show witch lean with myDissolve
                "[witch]" "Well, anyway, come by anytime you want to adjust your weaknesses, okay~?"
                "[witch]" "There should be a book on my desk. Simply opening it will let you manage your weaknesses~!"
                "[witch]" "If I'm ever out, feel free to do it yourself~!"
                $ witchCompleted = True
    
            else:
                pass

            $ game.slimeHouseUnlocked = True
            call forest_woodenShack_inside from _call_forest_woodenShack_inside 
            return

        "Hidden path to pond" if witchPathUnlocked:
            call move("forest_pond") from _call_move_21

        "Leave":
            call move("forest_3") from _call_move_22

    jump forest_woodenShack  

label forest_woodenShack_inside:
    scene shrine_inside_dynamic with myDissolve
    if witchCompleted:
        menu forest_woodenShack_inside_menu:
            "Talk to Emma":
                if getTimePeriod("night") == False:
                    $ isTalking = False
                    call witch_talk from _call_witch_talk
                else:
                    "She doesn't seem to be here right now..."
                    "...There's a book on the table that allows you to change your weaknesses anyways."
                    call screen weaknessesSelect with myDissolve
                    
            "Visit [slime.profile.name]'s room":
                call hideAllWitch from _call_hideAllWitch
                if slimePrincess in allPartyMembers:
                    "[slimePrincess]" "She's not worth our time..."
                    hide slimeprincess laugh with myDissolve
                else:
                    call forest_woodenShack_inside_slimeroom from _call_forest_woodenShack_inside_slimeroom
            "Leave":
                jump forest_woodenShack

    else:
        show slime_main with myDissolve
        menu:
            "Talk to [slime.profile.name]":
                call slime_talk from _call_slime_talk
                jump forest_woodenShack
                
            "Leave":
                "[slime]" "Aww~ Already?"
                "[slime]" "Okay, see you in the forest, [pronouns.mister]~"
                jump forest_woodenShack

        jump forest_woodenShack_inside

    
    jump forest_woodenShack_inside_menu

label forest_woodenShack_inside_slimeroom:
    if slime in allPartyMembers:
        pass
    else:
        show slime_main with myDissolve

    menu:
        "Talk to [slime.profile.name]":
            call slime_talk from _call_slime_talk_1 
            jump forest_woodenShack_inside

        "Leave":
            if slimePrincess in allPartyMembers:
                pass
            else:
                pass
            jump forest_woodenShack_inside

    jump forest_woodenShack_inside_slimeroom

# TODO: make more dynamic forest pics

label forest_shack_witchdead:
    "..."
    play audio recovery3
    hide fullPng with Fade(.1, .3, .2, color="#9ccb5b")
    call restoreAll from _call_restoreAll_5 
    "{color=#0f0} You restored all your health!"
    "[witch]" "Ahh~ There there, that's better~"
    scene shrine_inside_dynamic with myDissolve
    show witch smuglean with myDissolve
    "[witch]" "I hope I didn't overdo it~"
    "[witch]" "Gosh, your semen just feels so amazing though~"
    "[witch]" "I haven't felt a real adventurer's cum in so long~"
    "[witch]" "..."
    "[witch]" "But, I've already taken enough for now~"
    "[witch]" "Thanks, cutie~ That was fun~"
    if player.weaknesses.hands.resistance == -1:
        hide witch smuglean with myDissolve
        show witch laugh with myDissolve
        "[witch]" "Ahaha, I can't believe you actually lowered your hands weakness by the way~"
        "[witch]" "Maybe that just shows how easy you are, huh~?"
    elif player.weaknesses.hands.resistance > 0:
        hide witch smuglean with myDissolve
        show witch laugh with myDissolve
        "[witch]" "I'm actually surprised you decided to increase your hands resistance~"
        "[witch]" "Did you do it because you knew I was gonna use it against you? Or did you just want to tease me~?"
    hide witch laugh with myDissolve
    hide witch smuglean with myDissolve
    show witch lean with myDissolve
    "[witch]" "Well, anyway, don't worry about me draining more than you can handle~"
    "[witch]" "I'm a fair girl, come on~"
    hide witch lean with myDissolve
    show witch laugh with myDissolve
    "[witch]" "Well, anyway, come by anytime you want to adjust your weaknesses, okay~?"
    "[witch]" "There should be a book on my desk. Simply opening it will let you manage your weaknesses~!"
    "[witch]" "If I'm ever out, feel free to do it yourself~!"
    $ witchCompleted = True
    call forest_woodenShack_inside from _call_forest_woodenShack_inside_1 
    



define randomNumber = 0
define isWandering = False

label randomForestEvent(targetDepth):
    $ randomNumber = rand(1, 9)
    if (dangerAreaDepth == targetDepth):
            $ randomNumber = rand(1, 5)
            $ isWandering = True
            pause 0.1
    $ renpy.block_rollback()

    if randomNumber == 1:
        # shopkeeper event if its evening
        if getTimePeriod("evening"):
            if game.shopUnlocked and shopKeeperStatus != "walking" and player.money > 30 and ((player.health / player.maxHealth < 1) or (player.arousal > 0)):
                call event_forest_shopkeeper from _call_event_forest_shopkeeper 
            else:
                call forest_wander from _call_forest_wander 

        # otherwise do the slime choice event
        elif (player.XP > getXPRequirement(500) and game.levelDrainSlimeEvent and currentPartyMember.profile.pageId != "slime"):
                $ renpy.block_rollback()
                call restore(slime) from _call_restore 
                call forest_slime_choice from _call_forest_slime_choice 
                stop music fadeout 3
        else:
            call forest_wander from _call_forest_wander_1 
            
    elif randomNumber == 2:
        if(player.level < 5):
            call enterCombat(
                GameCharacter(
                    9, 10, 2, 50, 200,  
                    Profile("The lesser slime", "#1e88e5", "lesserslime",
                    "Lesser slimes are slimes fighting for the slime princess's army. They're fairly weak and don't have a strong work ethic, usually trying to slack off at every opertunity. Despite their low energy, they're very faithful towards their princess, doing almost anything just to drain some more XP to feed her. \n \n Their ways of draining are similar to most slimes. Using their body parts to pleasure humans until they cum inside their core.",
                    LesserSlime(color=(rand(0, 25) - 20))
                    ),
                    Conditions()
                )
            ) from _call_enterCombat_3 
        else:
            call enterCombat(
            GameCharacter(
                mathMin(player.level, 10) + rand(5, 8), 10, 2, 50, rand(150, mathMin(800, player.XP)),  
                Profile("The lesser slime", "#1e88e5", "lesserslime",
                "Lesser slimes are slimes fighting for the slime princess's army. They're fairly weak and don't have a strong work ethic, usually trying to slack off at every opertunity. Despite their low energy, they're very faithful towards their princess, doing almost anything just to drain some more XP to feed her. \n \n Their ways of draining are similar to most slimes. Using their body parts to pleasure humans until they cum inside their core.",
                LesserSlime(color=(rand(0, 25) - 20))
                ),
                Conditions()
            )
        ) from _call_enterCombat_4   

    elif randomNumber == 3:
            if(((player.level > 4 and slime.health > 1 and slime.winCount == 0) or (player.level > 8 and slime.health > 1 and slime.winCount > 0)) and currentPartyMember != slime):
                call enterCombat(slime) from _call_enterCombat_5 
            else:
                call forest_wander from _call_forest_wander_2 

    
    elif randomNumber == 4:
            if(player.level > 2 and harpy.health > 1 and currentPartyMember != harpy and (getTimePeriod("morning") or getTimePeriod("afternoon") or getTimePeriod("evening"))):
                call enterCombat(harpy) from _call_enterCombat_7
            else:
                call forest_wander from _call_forest_wander_3 

    elif randomNumber == 5:
        if (game.slimeHouseUnlocked and witchInvited == False):
            play audio bush volume 0.25
            "You hear sounds coming from a nearby bush..."
            "[anonTalk(witch.profile.color)]" "..."
            "You see a little kitty walk up to you..."
            "It's wearing a black witch hat and... human clothing"
            show witch cat stand at customPos(0.0, 0.2) with myDissolve
            "[anonTalk(witch.profile.color)]" "Sniff sniff..."
            "..."
            menu:
                "Pet the kitty":
                    call increaseFavor(witch, 1, 500, "???") from _call_increaseFavor_2
                    "You pet the kitty."
                    "It sniffs your hand."

                "Do not pet the kitty":
                    "You do not pet the kitty."
                    "The kitty walks off and leaves you alone..."
                    return

            "[anonTalk(witch.profile.color)]" "Sniff..."
            "[anonTalk(witch.profile.color)]" "You smell familiar..."
            "[anonTalk(witch.profile.color)]" "Like home..."
            "[anonTalk(witch.profile.color)]" "Why were you in my home?"
            show witch cat stand at customPos(0.0, 0.2), lookAround2() with myDissolve
            pause 1
            show witch cat stand at customPos(0.0, 0.2), lookBack2() with myDissolve
            pause 0.5
            "The kitty looks around..."
            "[anonTalk(witch.profile.color)]" "Wait a minute..."
            hide witch cat stand with myDissolve
            show witch cat smile with myDissolve
            "[anonTalk(witch.profile.color)]" "You must be that adventurer, right?"
            "[anonTalk(witch.profile.color)]" "I've never seen one before, wow~!"
            "[anonTalk(witch.profile.color)]" "My name is Emma, I live in the forest near here!"
            $ witch.profile.name = "Emma"
            "[witch]" "It's nice to meet you. Sorry about my attitude earlier."
            "[witch]" "I actually know a few tricks that might be useful on your adventure!"
            "[witch]" "You should come over to my house sometime, I can train you!"
            $ witchInvited = True
            "[witch]" "Come on, it'll be fun!"
            menu:
                "Follow her to her home":
                    "[witch]" "Great, come with me!"
                    scene black with myDissolve
                    "You follow the kitty deeper into the forest..."
                    jump forest_woodenShack_menu_inside
                    pass
                
                "Maybe later":
                    "[witch]" "Oh, okay."
                    "[witch]" "Well, see you later in that case, you're welcome to come anytime!"
                    hide witch cat smile with myDissolve
                    "The cat walks off..."


            # corrupt into monster girl, she wants to train you and becomes addicted to magic energy (cum) in the process
        
        elif (slime.profile.name == "Skye" and (isWandering or targetDepth == 3) and witchCompleted == False):
            "While wandering the forest, you take a wrong turn and..."
            jump forest_woodenShack
        
        else:
            call forest_wander from _call_forest_wander_4

            
                    
        
             
    
    $ renpy.block_rollback()
    
    call move("forest_" + str(targetDepth)) from _call_move_23 

label forest_wander:
    if isWandering:
        call randomForestEvent(targetDepth) from _call_randomForestEvent_7 
    return



















            # play audio holy7
            # show witch lean with Fade(0.1, .3, 0.3, color="#fff")
            # pause 0.5
            # "[witch]" "There, that's better~"
            # "[witch]" "I'm an adventurer too, just like you~"
            # "[witch]" "Hey, since you're an adventurer, why don't you come over to my house?"
            # "[witch]" "I could teach you a bunch of cool things~"
            # $ witchInvited = True
            # menu:
            #     "Come with her":
            #         pass
            #     "Maybe later":
            #         hide witch lean with myDissolve
            #         show witch stand with myDissolve
            #         "[witch]" "Oh, okay."
            #         "[witch]" "Well, see you later in that case."
            #         show witch cat stand at customPos(0.0, 0.2) 
            #         hide witch stand
            #         with Fade(0.1, .3, 0.3, color="#fff")
            #         "The cat walks off..."
            #         hide witch cat stand